' CreateGlobalObjects.vbs
' (c) 2014 Lugrain Software GmbH
' -----------------------
' Exportiert alle DHCP-Leases von einem Windows Server 2008 DHCP-Server
' in die Datei GlobalObjects.txt, die als Datenbasis fr AdminsRobot
' verwendet werden kann. Ordnet jedem PC die jeweiligen Benutzer zu.
' Die Benutzer mssen sich in einer Freigabe befinden.
' Das Skript muss mit ausreichend Berechtigungen ausgefhrt werden
' Dazu eine Eingabeaufforderung als Administrator starten und Befehl
' "wscripts ExportDhcp.vbs" ausfhren. Kann dann als geplanter 
' Task in der Windows Aufgabenplanung laufen, um eine jederzeit 
' aktuelle Datenbasis zu haben.

Set fs = CreateObject("Scripting.FileSystemObject")
Set Shell = CreateObject("Wscript.Shell")

dhcpserver = "MyDhcpServer"   ' hier den Namen des DHCP-Servers eintragen 
share = "\\MyFileServer\pc$"  ' hier die Freigabe eintragen, in der sich die Benutzerinformationen befinden
domainsuffix = ".domain.de"   ' hier den Domain-Suffix angeben, der entfernt werden soll

serverpattern1 = "server"     ' wenn im Hostnamen dieser Text enthalten ist, wird das Objekt als Server eingestuft
serverpattern2 = "srv"        ' wenn im Hostnamen dieser Text enthalten ist, wird das Objekt als Server eingestuft
printerpattern1 = "drucker"   ' wenn im Hostnamen dieser Text enthalten ist, wird das Objekt als Drucker eingestuft
printerpattern2 = "printer"   ' wenn im Hostnamen dieser Text enthalten ist, wird das Objekt als Drucker eingestuft

' Aktuellen Pfad ermitteln
pos1 = InstrRev(WScript.ScriptFullName, "\")
path = Left(WScript.ScriptFullName, pos1)

' DHCP-Scopes ermitteln
result = shell.run("cmd /c netsh dhcp server \\" & dhcpserver & " show scope >" & chr(34) & path & "temp_Scopes.txt", 1, true)   

' Leases ermitteln
result = shell.run("cmd /c del " & chr(34) & path & "temp_Leases.txt" & chr(34), 1, true)
Set ScopeFile = fs.OpenTextFile(path & "temp_Scopes.txt")
Do Until ScopeFile.AtEndOfStream
    zeile = ScopeFile.ReadLine
	if ((instr(zeile, "-Active")) Or (instr(zeile, "-Aktiv"))) then
		pos1 = instr(zeile, "-")
		if pos1 > 0 then
			scope = left(zeile, pos1 - 1)
			scope = Trim(scope)			
			' Fr jeden Scope die Leases ermitteln
			result = shell.run("cmd /c chcp 1250 & netsh dhcp server \\" & dhcpserver & " scope " & scope & " show clients 1 >>" & chr(34) & path & "temp_Leases.txt" & chr(34), 1, true)
			'msgbox scope
		end if
	
	end if   
Loop
ScopeFile.Close

' temp_HostMacIp.txt erzeugen - darin sind noch keine Benutzerinformationen enthalten
Set LeaseFile = fs.OpenTextFile(path & "temp_Leases.txt")

Set HostMacIpFile = fs.OpenTextFile(path & "temp_HostMacIp.txt", 2, true)

Do Until LeaseFile.AtEndOfStream
    zeile = LeaseFile.ReadLine
	if len(zeile) > 0 then
		zeichen = left(zeile,1)
		if Asc(left(zeile,1)) >= 49 and Asc(left(zeile,1)) <= 57 Then
			hostname = trim(mid(zeile, InStrRev(zeile, " ")))
			len_suffix = len(domainsuffix)
			if lcase(right(hostname, len_suffix)) = lcase(domainsuffix) then hostname = left(hostname, len(hostname) - len_suffix)
			temp = mid(zeile, InStr(zeile, "-") + 1)
			temp = ltrim(mid(temp, InStr(zeile, "-") + 1))
			mac = rtrim(left(temp, InStr(temp, " ")))
			ip = trim(left(zeile, InStr(zeile, " ")))
			if len(hostname) > 0 and len(mac) > 11 then
				HostMacIpFile.writeline hostname + "," + mac + "," + ip
			end if
	        End If
	end if
   
Loop
LeaseFile.Close
HostMacIpFile.Close


' ========================================================================================================

' Benutzer und Anmeldezeiten ermitteln

dim filenames(10000)
dim datum(10000)
dim users(100)
dim logon_dates(100)

Set fso = CreateObject("Scripting.FileSystemObject")
Set Shell = CreateObject("Wscript.Shell")

Set folder = fso.GetFolder(share)  
Set files = folder.Files    


' Alle Dateien aus pc$ in filenames() einlesen
i=1
For each file In files    
	datum(i) = file.DateLastModified
	pos1 = instrrev(file,"\")
	file = mid(file,pos1+1)
	filenames(i) = file
	i=i+1
	
Next  

	
anzahl_files = i - 1

' HostMacIp.txt wird durchlaufen und geschaut, ob mit filenames(i) ein Match besteht.
Set fs = CreateObject("Scripting.FileSystemObject")
Set HostFile = fs.OpenTextFile(path & "temp_HostMacIp.txt")
counter = 0
teffer = 0

Set OutputFile = fs.OpenTextFile(path & "GlobalObjects.txt", 2, true)

Do Until HostFile.AtEndOfStream
	
	zeile = HostFile.ReadLine
	ip = mid(zeile, InStrRev(zeile, ",")+1)
	zeile = left(zeile, InStrRev(zeile, ",")-1)
	pc = left(zeile,instr(zeile,",")-1)
	usercount = 0
	for i = 1 to anzahl_files
		pos1 = Instr(pc, ".")
		if pos1 > 0 Then pc = left(pc, pos1-1)   ' Domain-Suffix abschneiden, falls vorhanden
		if lcase(left(filenames(i),len(pc))) = lcase(pc) then   
			if mid(filenames(i), len(pc)+1, 1) = "_" then   ' Check, ob danach ein "_" folgt
				usercount = usercount + 1
				pos1 = instr(filenames(i), "_")
				users(usercount) = mid(filenames(i), pos1 + 1)   ' PC-Namen wegstreichen (alles vor Unterstrich)
				logon_dates(usercount) = datum(i)   ' DateLastModified
				if lcase(right(users(usercount),4)) = ".txt" then users(usercount) = left(users(usercount), len(users(usercount)) - 4)
				treffer = treffer + 1
			end if
		end if
	next
	
	description = ""
	neuestes_datum = ""
	neuester_user = ""

	if usercount > 0 then
		neuestes_datum = logon_dates(1)
		neuester_user = users(1)
		for x = 1 to usercount
			description = description + " " & users(x) 
			if logon_dates(x) > neuestes_datum then 
				neuestes_datum = logon_dates(x)   
				neuester_user = users(x)
			end if
		next
		if left(description,1) = " " then description = mid(description,2)
		' neuesten User entfernen (alle Kombinationen: Leerzeichen davon, dahinter, keins)
		description = replace(description, neuester_user & " ", "")
		description = replace(description, " " & neuester_user, "")
		description = replace(description, neuester_user, "")
		neuestes_datum = left(neuestes_datum, len(neuestes_datum) -3)   ' Sekunden entfernen
		description = " " & description
	end if

	typ = "Workstation"
	If ((InStr(LCase(pc), LCase(serverpattern1)) > 0) Or (InStr(LCase(pc), LCase(serverpattern2)) > 0)) Then typ = "Server"
	If ((InStr(LCase(pc), LCase(printerpattern1)) > 0) Or (InStr(LCase(pc), LCase(printerpattern2)) > 0)) Then typ = "Drucker"
	OutputFile.writeline zeile & ",,," & neuestes_datum & "," & neuester_user & rtrim(description) & "," & ip & "," & "," & typ 
    counter = counter + 1
Loop
HostFile.Close



' Kopieren an zentralen Ort
result = shell.run("cmd.exe /c copy " & chr(34) & path & "GlobalObjects.txt" + chr(34) + " " + chr(34) + "c:\temp" + chr(34), 1, true)   




     





