' ExportDhcp.vbs
' (c) 2014 Lugrain Software GmbH
' -----------------------
' Exportiert alle DHCP-Leases von einem Windows Server 2008 DHCP-Server
' in die Datei GlobalObjects.txt, die als Datenbasis fr AdminsRobot
' verwendet werden kann. 
' Das Skript muss mit ausreichend Berechtigungen ausgefhrt werden
' Dazu eine Eingabeaufforderung als Administrator starten und Befehl
' "wscripts ExportDhcp.vbs" ausfhren. Kann dann als geplanter 
' Task in der Windows Aufgabenplanung laufen, um eine jederzeit 
' aktuelle Datenbasis zu haben.

Set fs = CreateObject("Scripting.FileSystemObject")
Set Shell = CreateObject("Wscript.Shell")

dhcpserver = "MyDhcpServer"   ' hier den Namen des DHCP-Servers eintragen 
domainsuffix = ".domain.de"   ' hier den Domain-Suffix angeben, der entfernt werden soll


' Aktuellen Pfad ermitteln
pos1 = InstrRev(WScript.ScriptFullName, "\")
path = Left(WScript.ScriptFullName, pos1)

' DHCP-Scopes ermitteln
result = shell.run("cmd /c netsh dhcp server \\" & dhcpserver & " show scope >" & chr(34) & path & "temp_Scopes.txt", 1, true)   

' Leases ermitteln
result = shell.run("cmd /c del " & chr(34) & path & "temp_Leases.txt" & chr(34), 1, true)
Set ScopeFile = fs.OpenTextFile(path & "temp_Scopes.txt")
Do Until ScopeFile.AtEndOfStream
    zeile = ScopeFile.ReadLine
	if ((instr(zeile, "-Active")) Or (instr(zeile, "-Aktiv"))) then
		pos1 = instr(zeile, "-")
		if pos1 > 0 then
			scope = left(zeile, pos1 - 1)
			scope = Trim(scope)			
			' Fr jeden Scope die Leases ermitteln
			result = shell.run("cmd /c chcp 1250 & netsh dhcp server \\" & dhcpserver & " scope " & scope & " show clients 1 >>" & chr(34) & path & "temp_Leases.txt" & chr(34), 1, true)
			'msgbox scope
		end if
	
	end if   
Loop
ScopeFile.Close

' GlobalObjects.txt erzeugen - darin sind noch keine Benutzerinformationen enthalten
Set LeaseFile = fs.OpenTextFile(path & "temp_Leases.txt")

Set HostMacIpFile = fs.OpenTextFile(path & "GlobalObjects.txt", 2, true)

Do Until LeaseFile.AtEndOfStream
    zeile = LeaseFile.ReadLine
	if len(zeile) > 0 then
		zeichen = left(zeile,1)
		if Asc(left(zeile,1)) >= 49 and Asc(left(zeile,1)) <= 57 Then
			hostname = trim(mid(zeile, InStrRev(zeile, " ")))
			len_suffix = len(domainsuffix)
			if lcase(right(hostname, len_suffix)) = lcase(domainsuffix) then hostname = left(hostname, len(hostname) - len_suffix)
			temp = mid(zeile, InStr(zeile, "-") + 1)
			temp = ltrim(mid(temp, InStr(zeile, "-") + 1))
			mac = rtrim(left(temp, InStr(temp, " ")))
			ip = trim(left(zeile, InStr(zeile, " ")))
			if len(hostname) > 0 and len(mac) > 11 then
				HostMacIpFile.writeline hostname & "," & mac & ",,,,," & ip & ",,Workstation" 
			end if
	        End If
	end if
   
Loop
LeaseFile.Close
HostMacIpFile.Close




' Kopieren an zentralen Ort
result = shell.run("cmd.exe /c copy " & chr(34) & path & "GlobalObjects.txt" + chr(34) + " " + chr(34) + "c:\temp" + chr(34), 1, true)   




     





